## vxl 1.17.0

=== v3p/CMakeLists.txt ===
# v3p/CMakeLists.txt

PROJECT( vthreep )

SET( VTHREEP_INCLUDE_DIR ${vthreep_SOURCE_DIR} CACHE STATIC "v3p include files" )
SET( VTHREEP_INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_PREFIX}/include/vxl/v3p CACHE STATIC "v3p include files" )

# The borland compiler produces lots of warnings like
# Warning W8004 C:\cygwin\tmp\vxl_nightly_borland\vxl_src\v3p\tiff\tif_fax3.c 256:
#      'a0' is assigned a value that is never used in function Fax3Decode1D
# There is no point in us fixing them locally. IMS
IF (BORLAND)
  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -w-8004")
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -w-8004")
ENDIF (BORLAND)


IF (BUILD_CORE_NUMERICS)
  SUBDIRS(netlib)
ENDIF (BUILD_CORE_NUMERICS)

IF (BUILD_VGUI OR BUILD_FOR_VXL_DASHBOARD)
  SUBDIRS(Qv)
ENDIF (BUILD_VGUI OR BUILD_FOR_VXL_DASHBOARD)

IF (BUILD_CORE_IMAGING)
  OPTION( VXL_FORCE_V3P_ZLIB "Use V3P instead of any native ZLIB library?" NO)
  MARK_AS_ADVANCED( VXL_FORCE_V3P_ZLIB )
  SUBDIRS(zlib)

  OPTION( VXL_FORCE_V3P_BZLIB2 "Use V3P instead of any native BZip2 library?" NO)
  MARK_AS_ADVANCED( VXL_FORCE_V3P_BZLIB2 )
  SUBDIRS(bzlib)

  OPTION( VXL_FORCE_V3P_JPEG "Use V3P instead of any native JPEG library?" NO)
  MARK_AS_ADVANCED( VXL_FORCE_V3P_JPEG )
  SUBDIRS(jpeg)
  
# OPTION( VXL_FORCE_V3P_J2K "Use V3P instead of any native JPEG2000 library? (WIN32 only)" NO)
# MARK_AS_ADVANCED( VXL_FORCE_V3P_J2K )
# SUBDIRS(j2k)

  OPTION( VXL_FORCE_V3P_TIFF "Use V3P instead of any native TIFF library?" NO)
  MARK_AS_ADVANCED( VXL_FORCE_V3P_TIFF )
  SUBDIRS(tiff)

  OPTION( VXL_FORCE_V3P_GEOTIFF "Use V3P instead of any native GEOTIFF library?" NO)
  MARK_AS_ADVANCED( VXL_FORCE_V3P_GEOTIFF )
  SUBDIRS(geotiff)

  OPTION( VXL_FORCE_V3P_PNG "Use V3P instead of any native PNG library?" NO)
  MARK_AS_ADVANCED( VXL_FORCE_V3P_PNG )
  SUBDIRS(png)
  
  OPTION( VXL_FORCE_V3P_DCMTK "Use V3P instead of any native DCMTK library?" NO)
  MARK_AS_ADVANCED( VXL_FORCE_V3P_DCMTK )
  SUBDIRS(dcmtk)

  OPTION( VXL_FORCE_V3P_OPENJPEG2 "Use V3P instead of any native OpenJPEG v2 library?" NO)
  MARK_AS_ADVANCED( VXL_FORCE_V3P_OPENJPEG2 )
  SUBDIRS(openjpeg2)

  SUBDIRS(rply)

ENDIF (BUILD_CORE_IMAGING)

=== vcl/CMakeLists.txt ===
# vcl/CMakeLists.txt

IF(WIN32)
  # MSVC.NET produces lots of warnings like
  # "warning LNK4221: no public symbols found; archive member will be inaccessible"
  # that depend on subtle logic at compile time.
  # This is a bit indescriminate, but it may be the only feasible way to suppress them.
  IF (CMAKE_CXX_COMPILER MATCHES "^cl$")
    SET ( CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} /WARN:0")
    SET ( CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /WARN:0")
  ENDIF (CMAKE_CXX_COMPILER MATCHES "^cl$")
ENDIF(WIN32)


PROJECT( vcl )

# Set up vcl_where_root_dir.h to have a macro set to $VCL_SOURCE_ROOT_DIR
CONFIGURE_FILE(
  ${vxl_SOURCE_DIR}/vcl/vcl_where_root_dir.h.in
  ${vxl_BINARY_DIR}/vcl/vcl_where_root_dir.h ESCAPE_QUOTES
)

SET( vcl_sources
  vcl_compiler.h
  vcl_deprecated.cxx     vcl_deprecated.h

  vcl_where_root_dir.h.in
  vcl_config_compiler.h.in
  vcl_config_headers.h.in
  vcl_config_manual.h.in

  vcl_cmath.cxx          vcl_cmath.h
  vcl_cassert.cxx        vcl_cassert.h
  vcl_cstdlib.cxx        vcl_cstdlib.h

  vcl_algorithm.txx      vcl_algorithm.h
  vcl_bitset.h
  vcl_cctype.h
  vcl_cerrno.h
  vcl_cfloat.h
  vcl_ciso646.h
  vcl_climits.h
  vcl_clocale.h
  vcl_complex.txx        vcl_complex.h
  vcl_complex_fwd.h
  vcl_csetjmp.h
  vcl_csignal.h
  vcl_cstdarg.h
  vcl_cstddef.h
  vcl_cstdio.h
  vcl_cstring.h
  vcl_ctime.h
  vcl_cwchar.h
  vcl_cwctype.h
  vcl_deprecated_header.h
  vcl_deque.txx          vcl_deque.h
  vcl_exception.h
  vcl_fstream.h
  vcl_functional.txx     vcl_functional.h
  vcl_iomanip.h
  vcl_ios.h
  vcl_iosfwd.h
  vcl_iostream.h
  vcl_istream.h
  vcl_iterator.txx       vcl_iterator.h
  vcl_limits.h
  vcl_list.txx           vcl_list.h
  vcl_locale.h
  vcl_map.txx            vcl_map.h
  vcl_memory.h
  vcl_new.h
  vcl_numeric.h
  vcl_ostream.h
  vcl_queue.txx          vcl_queue.h
  vcl_set.txx            vcl_set.h
  vcl_sstream.h
  vcl_stack.txx          vcl_stack.h
  vcl_stdexcept.h
  vcl_stlfwd.h
  vcl_streambuf.h
  vcl_string.txx         vcl_string.h
  vcl_typeinfo.h
  vcl_utility.txx        vcl_utility.h
  vcl_valarray.h
  vcl_vector.txx         vcl_vector.h
  vcl_sys/time.h
  vcl_sys/types.h

  generic/vcl_algorithm.h
  generic/vcl_bitset.h
  generic/vcl_blah.h
  generic/vcl_cassert.h
  generic/vcl_cctype.h
  generic/vcl_cerrno.h
  generic/vcl_cfloat.h
  generic/vcl_ciso646.h
  generic/vcl_climits.h
  generic/vcl_clocale.h
  generic/vcl_cmath.h
  generic/vcl_complex.h
  generic/vcl_csetjmp.h
  generic/vcl_csignal.h
  generic/vcl_cstdarg.h
  generic/vcl_cstddef.h
  generic/vcl_cstdio.h
  generic/vcl_cstdlib.h
  generic/vcl_cstring.h
  generic/vcl_ctime.h
  generic/vcl_cwchar.h
  generic/vcl_cwctype.h
  generic/vcl_deque.h
  generic/vcl_exception.h
  generic/vcl_fstream.h
  generic/vcl_functional.h
  generic/vcl_iomanip.h
  generic/vcl_ios.h
  generic/vcl_iosfwd.h
  generic/vcl_iostream.h
  generic/vcl_istream.h
  generic/vcl_iterator.h
  generic/vcl_limits.h
  generic/vcl_list.h
  generic/vcl_locale.h
  generic/vcl_map.h
  generic/vcl_memory.h
  generic/vcl_memory_tr1.h
  generic/vcl_numeric.h
  generic/vcl_ostream.h
  generic/vcl_queue.h
  generic/vcl_set.h
  generic/vcl_sstream.h
  generic/vcl_stack.h
  generic/vcl_stdexcept.h
  generic/vcl_streambuf.h
  generic/vcl_string.h
  generic/vcl_typeinfo.h
  generic/vcl_utility.h
  generic/vcl_valarray.h
  generic/vcl_vector.h

  iso/vcl_algorithm.txx  iso/vcl_algorithm.h
  iso/vcl_complex.txx    iso/vcl_complex.h
  iso/vcl_deque.txx      iso/vcl_deque.h
  iso/vcl_functional.txx iso/vcl_functional.h
  iso/vcl_iterator.txx   iso/vcl_iterator.h
  iso/vcl_list.txx       iso/vcl_list.h
  iso/vcl_map.txx        iso/vcl_map.h
  iso/vcl_queue.txx      iso/vcl_queue.h
  iso/vcl_set.txx        iso/vcl_set.h
  iso/vcl_stack.txx      iso/vcl_stack.h
  iso/vcl_string.txx     iso/vcl_string.h
  iso/vcl_utility.txx    iso/vcl_utility.h
  iso/vcl_vector.txx     iso/vcl_vector.h
  iso/vcl_bitset.h
  iso/vcl_cassert.h
  iso/vcl_cctype.h
  iso/vcl_cerrno.h
  iso/vcl_cfloat.h
  iso/vcl_ciso646.h
  iso/vcl_climits.h
  iso/vcl_clocale.h
  iso/vcl_cmath.h
  iso/vcl_csetjmp.h
  iso/vcl_csignal.h
  iso/vcl_cstdarg.h
  iso/vcl_cstddef.h
  iso/vcl_cstdio.h
  iso/vcl_cstdlib.h
  iso/vcl_cstring.h
  iso/vcl_ctime.h
  iso/vcl_cwchar.h
  iso/vcl_cwctype.h
  iso/vcl_exception.h
  iso/vcl_fstream.h
  iso/vcl_iomanip.h
  iso/vcl_ios.h
  iso/vcl_iosfwd.h
  iso/vcl_iostream.h
  iso/vcl_istream.h
  iso/vcl_limits.h
  iso/vcl_locale.h
  iso/vcl_memory.h
  iso/vcl_memory_tr1.h
  iso/vcl_new.h
  iso/vcl_numeric.h
  iso/vcl_ostream.h
  iso/vcl_sstream.h
  iso/vcl_stdexcept.h
  iso/vcl_streambuf.h
  iso/vcl_typeinfo.h
  iso/vcl_valarray.h

  emulation/vcl_limits.cxx            emulation/vcl_limits.h
  emulation/vcl_string_instances.cxx
  emulation/vcl_rbtree_instances.cxx
  emulation/vcl_hashtable.cxx         emulation/vcl_hashtable.h
  emulation/vcl_alloc.cxx             emulation/vcl_alloc.h
  emulation/vcl_algorithm.txx         emulation/vcl_algorithm.h
  emulation/vcl_complex.txx           emulation/vcl_complex.h
  emulation/vcl_deque.txx             emulation/vcl_deque.h
  emulation/vcl_functional.txx        emulation/vcl_functional.h
  emulation/vcl_hash.txx
  emulation/vcl_hash_map.txx          emulation/vcl_hash_map.h
  emulation/vcl_iterator.txx          emulation/vcl_iterator.h
  emulation/vcl_list.txx              emulation/vcl_list.h
  emulation/vcl_map.txx               emulation/vcl_map.h
  emulation/vcl_multimap.txx          emulation/vcl_multimap.h
  emulation/vcl_rbtree.txx
  emulation/vcl_set.txx               emulation/vcl_set.h
  emulation/vcl_utility.txx           emulation/vcl_utility.h
  emulation/vcl_vector.txx            emulation/vcl_vector.h
  emulation/vcl_algobase.h
  emulation/vcl_bool.h
  emulation/vcl_bvector.h
  emulation/vcl_ciso646.h
  emulation/vcl_defalloc.h
  emulation/vcl_functionx.h
  emulation/vcl_hash_set.h
  emulation/vcl_heap.h
  emulation/vcl_multiset.h
  emulation/vcl_new.h
  emulation/vcl_pair.h
  emulation/vcl_rel_ops.h
  emulation/vcl_stack.h
  emulation/vcl_stlfwd.h
  emulation/vcl_tempbuf.h
  emulation/vcl_tree.h

  emulation/vcl_stlconf.h
  emulation/egcs-stlconf.h
  emulation/gcc-272-stlconf.h
  emulation/gcc-2800-stlconf.h
  emulation/gcc-281-stlconf.h
  emulation/gcc-295-stlconf.h
  emulation/sgi-CC-stlconf.h
  emulation/sun-CC4.1-stlconf.h
  emulation/sun-CC5.0-stlconf.h
  emulation/win32-vc50-stlconf.h
  emulation/stlcomp.h

  gcc/vcl_cmath.h
  gcc/vcl_cstdlib.h
  gcc-295/vcl_algorithm.txx
  gcc-295/vcl_complex.h               gcc-295/vcl_complex.txx
  gcc-295/vcl_deque.txx
  gcc-295/vcl_functional.txx
  gcc-295/vcl_iterator.txx
  gcc-295/vcl_list.txx
  gcc-295/vcl_map.txx
  gcc-295/vcl_memory.h
  gcc-295/vcl_queue.txx
  gcc-295/vcl_set.txx
  gcc-295/vcl_string.txx
  gcc-295/vcl_utility.txx
  gcc-295/vcl_vector.txx
  gcc-295/vcl_iomanip.h
  gcc-295/vcl_ios.h
  gcc-libstdcxx-v3/vcl_algorithm.txx
  gcc-libstdcxx-v3/vcl_deque.txx
  gcc-libstdcxx-v3/vcl_functional.txx
  gcc-libstdcxx-v3/vcl_iterator.txx
  gcc-libstdcxx-v3/vcl_list.txx
  gcc-libstdcxx-v3/vcl_map.txx
  gcc-libstdcxx-v3/vcl_set.txx
  gcc-libstdcxx-v3/vcl_string.txx
  gcc-libstdcxx-v3/vcl_utility.txx
  gcc-libstdcxx-v3/vcl_vector.txx
  egcs/vcl_algorithm.txx
  egcs/vcl_complex.txx
  egcs/vcl_deque.txx
  egcs/vcl_functional.txx
  egcs/vcl_iterator.txx
  egcs/vcl_list.txx
  egcs/vcl_map.txx
  egcs/vcl_set.txx
  egcs/vcl_string.txx
  egcs/vcl_utility.txx
  egcs/vcl_vector.txx

  sgi/vcl_algorithm.txx
  sgi/vcl_bitset.h
  sgi/vcl_cmath.h
  sgi/vcl_complex.txx               sgi/vcl_complex.h
  sgi/vcl_cstdlib.h
  sgi/vcl_deque.txx
  sgi/vcl_functional.txx
  sgi/vcl_iomanip.h
  sgi/vcl_ios.h
  sgi/vcl_iostream.h
  sgi/vcl_iterator.txx
  sgi/vcl_list.txx
  sgi/vcl_map.txx
  sgi/vcl_set.txx
  sgi/vcl_string.txx                sgi/vcl_string.h
  sgi/vcl_utility.txx
  sgi/vcl_vector.txx

  sunpro/vcl_algorithm.txx
  sunpro/vcl_cmath.h
  sunpro/vcl_complex.txx            sunpro/vcl_complex.h
  sunpro/vcl_cstdlib.h
  sunpro/vcl_deque.txx
  sunpro/vcl_functional.txx
  sunpro/vcl_iterator.txx           sunpro/vcl_iterator.h
  sunpro/vcl_list.txx
  sunpro/vcl_map.txx                sunpro/vcl_map.h
  sunpro/vcl_set.txx
  sunpro/vcl_stack.txx
  sunpro/vcl_utility.txx
  sunpro/vcl_vector.txx             sunpro/vcl_vector.h

  win32-vc60/vcl_cmath.h
  win32-vc60/vcl_complex.h
  win32-vc60/vcl_cstdarg.h
  win32-vc60/vcl_cstdlib.h
  win32-vc60/vcl_memory.h
  win32-vc60/vcl_string.h
  win32-vc60/vcl_valarray.h

  win32-vc70/vcl_cmath.h
  win32-vc70/vcl_complex.h
  win32-vc70/vcl_cstdlib.h
  win32-vc70/vcl_valarray.h

  win32-vc8/vcl_cmath.h
  win32-vc8/vcl_complex.h
  win32-vc8/vcl_cstdlib.h
  win32-vc8/vcl_valarray.h

  borland55/vcl_cfloat.h
  borland55/vcl_cmath.h
  borland55/vcl_complex.h
  borland55/vcl_cstdlib.h
  borland55/vcl_memory.h
  borland56/vcl_complex.h

  mwerks/vcl_cmath.h
  mwerks/vcl_complex.h
  mwerks/vcl_cstdlib.h

  stlport/vcl_cmath.h
  stlport/vcl_complex.h
  stlport/vcl_cstdlib.h

  # The following shall not be used other than as reference count for smart pointers
  vcl_atomic_count.h
  internal/vcl_atomic_count_gcc.h
  internal/vcl_atomic_count_gcc_x86.h
  internal/vcl_atomic_count_pthreads.h
  internal/vcl_atomic_count_solaris.h
  internal/vcl_atomic_count_sync.h
  internal/vcl_atomic_count_win32.h
  internal/vcl_interlocked.h
)

# We use implicit instantiation of the standard library now,
# so we shouldn't be explicitly instantiating anything.
# This also avoid trouble where the instantiation hack conflict
# with modern, more compliant compilers.
#AUX_SOURCE_DIRECTORY(Templates vcl_sources)

ADD_LIBRARY(vcl ${vcl_sources})

# CMake can automatically figure out the compiler characteristics on
# Windows too.  No need to do manual config.

# IF(WIN32)
#   IF(NOT CYGWIN)
#     ADD_DEFINITIONS( -DBUILDING_VCL_DLL )
#     INCLUDE_DIRECTORIES( config.win32 )
#   ENDIF(NOT CYGWIN)
# ENDIF(WIN32)

IF(UNIX)
  TARGET_LINK_LIBRARIES( vcl m )
ENDIF(UNIX)

# Installation
INSTALL_TARGETS(/lib vcl)
INSTALL_NOBASE_HEADER_FILES(/include/vxl/vcl ${vcl_sources})

# INCLUDE( ${vxl_SOURCE_DIR}/vcl/LinkSTLPort.cmake )

IF( BUILD_TESTING)
  SUBDIRS(tests)
ENDIF( BUILD_TESTING)

=== contrib/brl/CMakeLists.txt ===
# brl/CMakeLists.txt
# Mutual dependencies:  bbas --> bseg  and  bbas --> bmvl

PROJECT( brl )

doxygen_add_package(contrib/brl "Brown University Libraries")

# In contrib/brl there is sometimes an "extra" level in the directory structure
# (.../contrib/brl/{bbas,bseg,bmvl}/foo/foo.h)
# Setting BRL_INCLUDE_DIR in this way allows #include <foo/foo.h> without
# having to know the internal directory structure.
# The root directory should be listed last in case anyone tries to append to this path
SET( BRL_INCLUDE_DIR "${brl_SOURCE_DIR}/bbas;${brl_BINARY_DIR}/bbas;${brl_SOURCE_DIR}/bseg;${brl_SOURCE_DIR}/bpro;${brl_SOURCE_DIR}" CACHE STATIC "Brown University package include files" FORCE )
SET( BRL_BINARY_DIR "${brl_BINARY_DIR}")
SET( BRL_INSTALL_INCLUDE_DIR
  ${CMAKE_INSTALL_PREFIX}/include/vxl/contrib/brl
  ${CMAKE_INSTALL_PREFIX}/include/vxl/contrib/brl/bbas
  ${CMAKE_INSTALL_PREFIX}/include/vxl/contrib/brl/bseg
  ${CMAKE_INSTALL_PREFIX}/include/vxl/contrib/brl/bpro
  CACHE INTERNAL "Brown University package include files"
)

# Location of brl's private FindXXX.cmake CMake modules.
SET( BRL_CMAKE_DIR ${vxl_SOURCE_DIR}/contrib/brl/bmods )
# This is identical to BRL_CMAKE_DIR.  Perhaps we should eliminate BRL_MODULE_PATH?
SET( BRL_MODULE_PATH ${vxl_SOURCE_DIR}/contrib/brl/bmods )

INCLUDE_DIRECTORIES( ${VXLCORE_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BRL_INCLUDE_DIR} )

IF(UNIX)
  FIND_PROGRAM(CMAKE_UNAME uname /usr/bin /bin /usr/local/bin )
  IF(CMAKE_UNAME)
    EXEC_PROGRAM(uname ARGS -m OUTPUT_VARIABLE CMAKE_SYSTEM_PROCESSOR)
    SET(CMAKE_SYSTEM_PROCESSOR ${CMAKE_SYSTEM_PROCESSOR} CACHE INTERNAL "processor type (i386 and x86_64)")
    IF(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
      ADD_DEFINITIONS(-fPIC)
    ENDIF(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
  ENDIF(CMAKE_UNAME)
ENDIF(UNIX)

# basic services package
SUBDIRS(bbas)

IF( BUILD_GEL )
  # segmentation package
  SUBDIRS(bseg)
ENDIF( BUILD_GEL )

# process libraries
SUBDIRS(bpro)

# 3rd party libraries
SUBDIRS(b3p)

# cvg library
SUBDIRS(cvg)

=== contrib/cul/CMakeLists.txt ===
# ./cul/CMakeLists.txt

PROJECT( cul )

doxygen_add_package(contrib/gel "Cornell University Libraries")


SET( VXL_CUL_INCLUDE_DIR ${cul_SOURCE_DIR} CACHE STATIC "Cornell University package include files" )
SET( 
  CUL_INSTALL_INCLUDE_DIR 
  ${CMAKE_INSTALL_PREFIX}/include/vxl/contrib/cul 
  CACHE INTERNAL "Cornell University package include files" )


INCLUDE_DIRECTORIES( ${VXL_CORE_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${VXL_CUL_INCLUDE_DIR} )

# The bundler library requires BRL, RPL, and GEL
IF(BUILD_BRL AND BUILD_GEL AND BUILD_RPL)
  SUBDIRS( bundler )
ENDIF(BUILD_BRL AND BUILD_GEL AND BUILD_RPL)

=== contrib/oxl/CMakeLists.txt ===
# oxl/CMakeLists.txt

PROJECT( oxl )

doxygen_add_package(contrib/oxl "Oxford University Libraries")

SET( OXL_INCLUDE_DIR ${oxl_SOURCE_DIR} CACHE STATIC "Oxford University package include files" )
SET( OXL_INSTALL_INCLUDE_DIR
  ${CMAKE_INSTALL_PREFIX}/include/vxl/contrib/oxl
  CACHE INTERNAL "Oxford University package include files"
)

INCLUDE_DIRECTORIES(${VXLCORE_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${OXL_INCLUDE_DIR})

# These four libraries are mutually independent:
SUBDIRS(mvl vrml osl)

# using vgui:
IF( BUILD_VGUI )
  SUBDIRS(xcv apps)
ENDIF( BUILD_VGUI )

=== contrib/rpl/CMakeLists.txt ===
PROJECT( rpl )

doxygen_add_package(contrib/rpl "RPI Libraries")

SET( RPL_INCLUDE_DIR ${rpl_SOURCE_DIR} CACHE STATIC "RPI package include files" )
SET( RPL_INSTALL_INCLUDE_DIR
  ${CMAKE_INSTALL_PREFIX}/include/vxl/contrib/rpl
  CACHE INTERNAL "RPI package include files"
)

INCLUDE_DIRECTORIES( ${VXLCORE_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${RPL_INCLUDE_DIR} )

SUBDIRS( rrel )
SUBDIRS( rsdl )
IF (BUILD_MUL)
  SUBDIRS( rgrl )
ENDIF (BUILD_MUL)

OPTION(BUILD_RPL_RGTL "Build Rensselaer Generic Tree Library (rgtl)" OFF)
MARK_AS_ADVANCED(BUILD_RPL_RGTL)
IF(BUILD_RPL_RGTL)
  SUBDIRS( rgtl )

  OPTION(BUILD_RPL_RTVL "Build Rensselaer Tensor Voting Library (rtvl)" OFF)
  MARK_AS_ADVANCED(BUILD_RPL_RTVL)
  IF(BUILD_RPL_RTVL)
    SUBDIRS( rtvl )
  ENDIF(BUILD_RPL_RTVL)
ENDIF(BUILD_RPL_RGTL)

=== core/tests/CMakeLists.txt ===
# This is core/tests/CMakeLists.txt

# The tests here are general vxl configuration tests, and should not
# depend on any libraries other than vcl and testlib.

# header to tell test_build_info values of vxl_BUILD_DIR, BUILD_NAME,
# and SITE from CMake
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/test_build_info.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/test_build_info.h
                @ONLY IMMEDIATE)

# needed for generated test_build_info.h
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} )

# these defines are set (possibly) so the core_test_config test can
# report whether CMake has set these CMake variables
IF( UNIX )
  ADD_DEFINITIONS( -DCMAKE_DEFINES_VARIABLE_UNIX )
ENDIF( UNIX )
IF( CYGWIN )
  ADD_DEFINITIONS( -DCMAKE_DEFINES_VARIABLE_CYGWIN )
ENDIF( CYGWIN )
IF( MINGW )
  ADD_DEFINITIONS( -DCMAKE_DEFINES_VARIABLE_MINGW )
ENDIF( MINGW )
IF( WIN32 )
  ADD_DEFINITIONS( -DCMAKE_DEFINES_VARIABLE_WIN32 )
ENDIF( WIN32 )
IF( APPLE )
  ADD_DEFINITIONS( -DCMAKE_DEFINES_VARIABLE_APPLE )
ENDIF( APPLE )

ADD_EXECUTABLE( core_test_all
  test_driver.cxx
  test_config.cxx
  test_build_info.cxx test_build_info.h.in
)
TARGET_LINK_LIBRARIES( core_test_all testlib vcl )

ADD_EXECUTABLE( vxl_test_include test_include.cxx )

ADD_TEST( core_test_config ${EXECUTABLE_OUTPUT_PATH}/core_test_all test_config )
ADD_TEST( core_test_build_info ${EXECUTABLE_OUTPUT_PATH}/core_test_all test_build_info )

# a simple Dart notes file, in case test_build_info fails
IF( COMMAND WRITE_FILE )
  WRITE_FILE(
    "${vxl_BINARY_DIR}/Testing/HTML/TestingResults/Sites/${SITE}/${BUILDNAME}/BuildNameNotes.xml"
    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
    "<Site BuildName=\"${BUILDNAME}\" Name=\"${SITE}\">\n"
    "<BuildNameNotes>\n"
    "<Note>\n"
    "<DateTime>unset</DateTime>\n"
    "<Text>\n"
    "The full test_build_info did not run.\n"
    "Here is some basic information:\n"
    "vxl_SOURCE_DIR = ${vxl_SOURCE_DIR}\n"
    "vxl_BINARY_DIR = ${vxl_BINARY_DIR}\n"
    "CMAKE_C_COMPILER = ${CMAKE_C_COMPILER}\n"
    "CMAKE_C_FLAGS = ${CMAKE_C_FLAGS}\n"
    "CMAKE_CXX_COMPILER = ${CMAKE_CXX_COMPILER}\n"
    "CMAKE_CXX_FLAGS = ${CMAKE_CXX_FLAGS}\n"
    "CMAKE_SYSTEM = ${CMAKE_SYSTEM}\n"
    "CMAKE_MAKE_PROGRAM = ${CMAKE_MAKE_PROGRAM}\n"
    "</Text>\n"
    "</Note>\n"
    "</BuildNameNotes>\n"
    "</Site>\n"
  )
ENDIF( COMMAND WRITE_FILE )

ADD_EXECUTABLE( vxl_echo vxl_echo.cxx )
TARGET_LINK_LIBRARIES( vxl_echo vcl )


# Deal with unavailablility of FILE(TO_CMAKE_PATH ...)
SET( MYMAKECOMMAND ${MAKECOMMAND})

IF (CMAKE_MAJOR_VERSION GREATER 2)
 FILE(TO_CMAKE_PATH ${MAKECOMMAND} MYMAKECOMMAND)
ENDIF (CMAKE_MAJOR_VERSION GREATER 2)

IF (CMAKE_MAJOR_VERSION EQUAL 2)
  IF (CMAKE_MINOR_VERSION  GREATER 3)
     FILE(TO_CMAKE_PATH ${MAKECOMMAND} MYMAKECOMMAND)
  ENDIF (CMAKE_MINOR_VERSION  GREATER 3)
ENDIF (CMAKE_MAJOR_VERSION EQUAL 2)


ADD_TEST( cmake_config ${EXECUTABLE_OUTPUT_PATH}/vxl_echo nl
          MAKECOMMAND: ${MYMAKECOMMAND} nl
          CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS} nl
          CMAKE_C_FLAGS: ${CMAKE_C_FLAGS} nl
          BUILD_SHARED_LIBS: ${BUILD_SHARED_LIBS} nl
          CMAKE_EXE_LINKER_FLAGS: ${CMAKE_EXE_LINKER_FLAGS} nl
          CMAKE_MODULE_LINKER_FLAGS: ${CMAKE_MODULE_LINKER_FLAGS} nl
          CMAKE_SHARED_LINKER_FLAGS: ${CMAKE_SHARED_LINKER_FLAGS} nl
          VXL_USE_CMAKE_CONFIGURE: ${VXL_USE_CMAKE_CONFIGURE} nl
          )

=== core/vbl/CMakeLists.txt ===
# vxl/vbl/CMakeLists.txt

doxygen_add_library(core/vbl
  DEPENDS core/vsl
  PACKAGE core
  DESCRIPTION "Basic Template Library"
  )

SET( vbl_sources
  vbl_fwd.h

  vbl_bool_ostream.cxx        vbl_bool_ostream.h
  vbl_smart_ptr.txx           vbl_smart_ptr.h
                              vbl_shared_pointer.h
                              vbl_scoped_ptr.h
                              vbl_checked_delete.h
  vbl_sort.txx                vbl_sort.h           vbl_sort.cxx
  vbl_qsort.cxx               vbl_qsort.h

  vbl_array_1d.txx            vbl_array_1d.h
  vbl_array_2d.txx            vbl_array_2d.h
  vbl_array_3d.txx            vbl_array_3d.h
  vbl_bit_array_2d.cxx        vbl_bit_array_2d.h
  vbl_bit_array_3d.cxx        vbl_bit_array_3d.h
  vbl_sparse_array_base.txx   vbl_sparse_array_base.h
  vbl_sparse_array_1d.txx     vbl_sparse_array_1d.h
  vbl_sparse_array_2d.txx     vbl_sparse_array_2d.h
  vbl_sparse_array_3d.txx     vbl_sparse_array_3d.h
  vbl_big_sparse_array_3d.txx vbl_big_sparse_array_3d.h
  vbl_batch_multimap.h
  vbl_batch_compact_multimap.h

                              vbl_ref_count.h
  vbl_bounding_box.txx        vbl_bounding_box.h

  vbl_triple.txx              vbl_triple.h
  vbl_quadruple.txx           vbl_quadruple.h
  vbl_local_minima.txx        vbl_local_minima.h
  vbl_attributes.txx          vbl_attributes.h
)

AUX_SOURCE_DIRECTORY(Templates vbl_sources)

ADD_LIBRARY(vbl ${vbl_sources})
TARGET_LINK_LIBRARIES( vbl vcl )

INSTALL_TARGETS(/lib vbl)
INSTALL_NOBASE_HEADER_FILES(/include/vxl/core/vbl ${vbl_sources})

IF( BUILD_EXAMPLES )
  SUBDIRS( examples )
ENDIF( BUILD_EXAMPLES )

IF( BUILD_TESTING )
  SUBDIRS(tests)
ENDIF( BUILD_TESTING )

=== core/vgui/CMakeLists.txt ===
# core/vgui/CMakeLists.txt

PROJECT(vgui)

doxygen_add_library(core/vgui
  DEPENDS core/vgl core/vpl core/vbl core/vul core/vnl core/vil core/vil1
  PACKAGE core-L2
  DESCRIPTION "Multi-platform user-interface using OpenGL"
)

# Default the dashboard builds to "YES" so that
# we have some clients that try to compile vgui
OPTION( BUILD_VGUI "Build VGUI" ${YES_FOR_DASHBOARD} )

# Flag that determines if we were able to successfully build vgui.
# Initialize to NO. Change below if yes.
SET( VGUI_FOUND "NO" CACHE INTERNAL "Was vgui successfully built?" )

IF( BUILD_VGUI )

INCLUDE(${CMAKE_ROOT}/Modules/FindOpenGL.cmake)

# Build here only if OpenGL is available:
IF (OPENGL_FOUND)
 IF (OPENGL_GLU_FOUND)

  # For (not) reporting an error below
  SET( CAN_BUILD_VGUI "YES" )

  # Apple can use OpenGL either with or without X11
  # Finding X11 can cause problems when the native
  # Apple OpenGL is to be used.
  IF(APPLE)
    OPTION(VGUI_USE_X11 "Use OpenGL for X11" NO)
    IF(VGUI_USE_X11)
      INCLUDE(${CMAKE_ROOT}/Modules/FindX11.cmake)
    ENDIF(VGUI_USE_X11)
  ELSE(APPLE)
    INCLUDE(${CMAKE_ROOT}/Modules/FindX11.cmake)
  ENDIF(APPLE)
  # Qv needed by vrml only
  INCLUDE(${VXL_CMAKE_DIR}/FindQv.cmake)
  # glut optionally used by vgui_text and by the glut toolkit
  # implementation
  INCLUDE(${CMAKE_ROOT}/Modules/FindGLUT.cmake)

  # The following are for the optional toolkit
  # implementations
  INCLUDE(${CMAKE_ROOT}/Modules/FindQt.cmake)
  INCLUDE(${CMAKE_ROOT}/Modules/FindGTK.cmake)
  INCLUDE(${VXL_CMAKE_DIR}/NewCMake/FindGTK2.cmake)
  INCLUDE(${VXL_CMAKE_DIR}/NewCMake/FindWin32SDK.cmake)
  IF(NOT MINGW)
    # MFC is not available in MinGW.
    # This should be fixed in FindMFC.cmake and then this IF can be removed
    INCLUDE(${CMAKE_ROOT}/Modules/FindMFC.cmake)
  ENDIF(NOT MINGW)

  #SET(WXWIDGETS_USE_LIBS base core gl)
  #FIND_PACKAGE(wxWidgets)
  #INCLUDE(${VXL_CMAKE_DIR}/NewCMake/FindwxWidgets.cmake)
  FIND_PACKAGE(wxWidgets COMPONENTS base core gl)

  INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
  IF( GLUT_FOUND )
    INCLUDE_DIRECTORIES(${GLUT_INCLUDE_DIR})
  ENDIF( GLUT_FOUND )

SET(vgui_sources
  vgui_fwd.h
  vgui_config.h.in

  # basic classes
  vgui.cxx                      vgui.h
  vgui_toolkit.cxx              vgui_toolkit.h
  vgui_tag.cxx                  vgui_tag.h
  vgui_window.cxx               vgui_window.h
  vgui_adaptor.cxx              vgui_adaptor.h
  vgui_tableau.cxx              vgui_tableau.h    vgui_tableau_sptr.h
  vgui_parent_child_link.cxx    vgui_parent_child_link.h
  vgui_key.cxx                  vgui_key.h
  vgui_button.cxx               vgui_button.h
  vgui_modifier.cxx             vgui_modifier.h
  vgui_event.cxx                vgui_event.h
  vgui_command.cxx              vgui_command.h    vgui_command_sptr.h
  vgui_menu.cxx                 vgui_menu.h
  vgui_popup_params.h
  vgui_message.h
  vgui_observer.cxx             vgui_observer.h
  vgui_observable.cxx           vgui_observable.h
  vgui_satellite_tableau.txx vgui_satellite_tableau.h
  vgui_font.cxx                 vgui_font.h       vgui_font_sptr.h
  vgui_font_bitmap.cxx          vgui_font_bitmap.h
  vgui_font_textured.cxx        vgui_font_textured.h

  # utility
  vgui_find.cxx                 vgui_find.h
  vgui_utils.cxx                vgui_utils.h
  vgui_macro.cxx                vgui_macro.h
  vgui_color.cxx                vgui_color.h
  vgui_projection_inspector.cxx vgui_projection_inspector.h
  vgui_matrix_state.cxx         vgui_matrix_state.h
  vgui_text_graph.cxx           vgui_text_graph.h
  vgui_camera.cxx               vgui_camera.h
  vgui_event_condition.cxx      vgui_event_condition.h

  # images
  internals/vgui_rasterpos.cxx  internals/vgui_rasterpos.h
  vgui_pixel.cxx                vgui_pixel.h
  vgui_section_render.cxx       vgui_section_render.h
  vgui_section_buffer.cxx       vgui_section_buffer.h
  vgui_range_map_params.h       vgui_range_map_params_sptr.h
  vgui_range_map_params.cxx
  vgui_range_map.txx            vgui_range_map.h
  vgui_texture_hacks.cxx        vgui_texture_hacks.h
  vgui_cache_wizard.cxx         vgui_cache_wizard.h
  vgui_image_renderer.cxx       vgui_image_renderer.h
  vgui_vil_image_renderer.cxx   vgui_vil_image_renderer.h
  vgui_image_tableau.cxx        vgui_image_tableau.h      vgui_image_tableau_sptr.h
  vgui_blender_tableau.cxx      vgui_blender_tableau.h    vgui_blender_tableau_sptr.h

  # tableau mixins and miscellaneous
  vgui_wrapper_tableau.cxx      vgui_wrapper_tableau.h    vgui_wrapper_tableau_sptr.h
  vgui_deck_tableau.cxx         vgui_deck_tableau.h       vgui_deck_tableau_sptr.h
  vgui_composite_tableau.cxx    vgui_composite_tableau.h  vgui_composite_tableau_sptr.h
  vgui_poly_tableau.cxx         vgui_poly_tableau.h       vgui_poly_tableau_sptr.h
  vgui_grid_tableau.cxx         vgui_grid_tableau.h       vgui_grid_tableau_sptr.h
  vgui_drag_mixin.cxx           vgui_drag_mixin.h
  vgui_active_tableau.cxx       vgui_active_tableau.h     vgui_active_tableau_sptr.h
  vgui_selector_tableau.cxx     vgui_selector_tableau.h   vgui_selector_tableau_sptr.h
                                vgui_drag_tableau.h       vgui_drag_tableau_sptr.h
  vgui_clear_tableau.cxx        vgui_clear_tableau.h      vgui_clear_tableau_sptr.h
  vgui_debug_tableau.cxx        vgui_debug_tableau.h      vgui_debug_tableau_sptr.h
  vgui_quit_tableau.cxx         vgui_quit_tableau.h       vgui_quit_tableau_sptr.h
  vgui_tview_launcher_tableau.cxx vgui_tview_launcher_tableau.h vgui_tview_launcher_tableau_sptr.h
  vgui_shell_tableau.cxx        vgui_shell_tableau.h      vgui_shell_tableau_sptr.h
  vgui_text_put.cxx             vgui_text_put.h
  vgui_text_tableau.cxx         vgui_text_tableau.h       vgui_text_tableau_sptr.h
  vgui_blackbox_tableau.cxx     vgui_blackbox_tableau.h   vgui_blackbox_tableau_sptr.h
  vgui_enhance_tableau.cxx      vgui_enhance_tableau.h    vgui_enhance_tableau_sptr.h
  vgui_tview_tableau.cxx        vgui_tview_tableau.h      vgui_tview_tableau_sptr.h
  vgui_function_tableau.cxx     vgui_function_tableau.h   vgui_function_tableau_sptr.h
  vgui_roi_tableau.cxx          vgui_roi_tableau.h        vgui_roi_tableau_sptr.h
  vgui_rubberband_tableau.cxx   vgui_rubberband_tableau.h vgui_rubberband_tableau_sptr.h
  vgui_loader_tableau.cxx       vgui_loader_tableau.h     vgui_loader_tableau_sptr.h
  vgui_color_text.cxx           vgui_color_text.h
  vgui_event_server.cxx         vgui_event_server.h
  vgui_error_dialog.cxx         vgui_error_dialog.h

  vgui_soview.cxx               vgui_soview.h
  vgui_soview2D.cxx             vgui_soview2D.h
  vgui_soview3D.cxx             vgui_soview3D.h
  vgui_style.cxx                vgui_style.h                vgui_style_sptr.h
  vgui_displaybase_tableau.cxx  vgui_displaybase_tableau.h  vgui_displaybase_tableau_sptr.h
  vgui_displaylist2D_tableau.cxx  vgui_displaylist2D_tableau.h vgui_displaylist2D_tableau_sptr.h
  vgui_displaylist3D_tableau.cxx  vgui_displaylist3D_tableau.h vgui_displaylist3D_tableau_sptr.h
  vgui_easy2D_tableau.cxx       vgui_easy2D_tableau.h       vgui_easy2D_tableau_sptr.h
  vgui_easy3D_tableau.cxx       vgui_easy3D_tableau.h       vgui_easy3D_tableau_sptr.h
  vgui_listmanager2D_tableau.cxx  vgui_listmanager2D_tableau.h  vgui_listmanager2D_tableau_sptr.h
  vgui_viewer2D_tableau.cxx vgui_viewer2D_tableau.h         vgui_viewer2D_tableau_sptr.h
  vgui_viewer3D_tableau.cxx vgui_viewer3D_tableau.h         vgui_viewer3D_tableau_sptr.h
  internals/trackball.c              internals/trackball.h

  vgui_slider_tableau.cxx       vgui_slider_tableau.h       vgui_slider_tableau_sptr.h

  # dialog classes
  vgui_dialog.cxx                    vgui_dialog.h
  vgui_dialog_extensions.cxx         vgui_dialog_extensions.h
  internals/vgui_dialog_impl.cxx     internals/vgui_dialog_impl.h
  internals/vgui_dialog_extensions_impl.cxx     internals/vgui_dialog_extensions_impl.h
  internals/vgui_dialog_field.h
  internals/vgui_simple_field.h      internals/vgui_simple_field.cxx
  internals/vgui_string_field.h
  internals/vgui_file_field.h
  internals/vgui_button_field.h

  # statusbar classes
  vgui_statusbuf.cxx            vgui_statusbuf.h
  vgui_statusbar.h

  # extra header files
  dll.h
  vgui_gl.h
  vgui_glu.h
  vgui_glx.h

  # internals
  internals/vgui_invert_homg4x4.cxx  internals/vgui_invert_homg4x4.h
  internals/vgui_back_project.cxx    internals/vgui_back_project.h
  internals/vgui_un_project.cxx      internals/vgui_un_project.h
  internals/vgui_adaptor_tableau.cxx internals/vgui_adaptor_tableau.h
  internals/vgui_parent_child_link_data.h
  internals/vgui_adaptor_mixin.h
  internals/vgui_overlay_helper.cxx  internals/vgui_overlay_helper.h
  internals/vgui_multiply_4x4.cxx    internals/vgui_multiply_4x4.h
  internals/vgui_transpose_4x4.cxx   internals/vgui_transpose_4x4.h
  internals/vgui_draw_line.cxx       internals/vgui_draw_line.h
  # Mesa-X11-mfc accelerated functions using Hermes
  internals/vgui_accelerate.cxx      internals/vgui_accelerate.h
  internals/vgui_accelerate_tag.cxx
  internals/vgui_gl_selection_macros.h
)

IF( GLUT_FOUND )
  SET(vgui_sources ${vgui_sources}
    vgui_glut.cxx                    vgui_glut.h
  )
ENDIF( GLUT_FOUND )

AUX_SOURCE_DIRECTORY(Templates vgui_sources)

IF (QV_FOUND)
  INCLUDE_DIRECTORIES(${QV_INCLUDE_DIR})
  SET(vgui_sources ${vgui_sources}
    vrml/vgui_vrml_draw_visitor.cxx  vrml/vgui_vrml_draw_visitor.h
    vrml/vgui_vrml_tableau.cxx       vrml/vgui_vrml_tableau.h
    vrml/vgui_vrml_texture_map.cxx   vrml/vgui_vrml_texture_map.h
  )
ENDIF (QV_FOUND)

IF (MFC_FOUND)
  #SET(vgui_sources ${vgui_sources}
  #    internals/vgui_accelerate_mfc.cxx internals/vgui_accelerate_mfc.h
  #   )
ENDIF (MFC_FOUND)

IF (X11_FOUND)
  INCLUDE_DIRECTORIES(${X11_INCLUDE_DIR})
  SET(vgui_sources ${vgui_sources}
      internals/vgui_accelerate_x11.cxx internals/vgui_accelerate_x11.h
     )
ENDIF (X11_FOUND)

IF (MFC_FOUND)
  # add stuff to use MFC in this executable
  ADD_DEFINITIONS( "-D_AFXDLL" )
  SET(CMAKE_MFC_FLAG 2)
ENDIF (MFC_FOUND)


######################################################################
# TOOLKIT IMPLEMENTATIONS
######################################################################

##################################################
# glut
##################################################

# Build here only if GLUT is available:
IF (GLUT_FOUND)

  OPTION(VGUI_USE_GLUT "Should Glut support be compiled into vgui?" YES)

  IF(VGUI_USE_GLUT)

    INCLUDE_DIRECTORIES(${GLUT_INCLUDE_DIR})

    SET(vgui_glut_sources
      impl/glut/vgui_glut_adaptor.cxx    impl/glut/vgui_glut_adaptor.h
      impl/glut/vgui_glut_tag.cxx
      impl/glut/vgui_glut_popup_impl.cxx impl/glut/vgui_glut_popup_impl.h
      impl/glut/vgui_glut_window.cxx     impl/glut/vgui_glut_window.h
      impl/glut/vgui_glut_impl.cxx       impl/glut/vgui_glut_impl.h

      impl/glut/menu_hack.h
    )
    IF (X11_FOUND AND NOT APPLE)
      INCLUDE_DIRECTORIES(${X11_INCLUDE_DIR})
     # FreeGLUT does not support this menu hack
      IF(EXISTS ${GLUT_INCLUDE_DIR}/GL/freeglut.h)
        SET(vgui_glut_sources ${vgui_glut_sources}
          impl/glut/menu_hack_none.cxx
        )
      ELSE(EXISTS ${GLUT_INCLUDE_DIR}/GL/freeglut.h)
        SET(vgui_glut_sources ${vgui_glut_sources}
          impl/glut/menu_hack_X11.cxx
        )
      ENDIF(EXISTS ${GLUT_INCLUDE_DIR}/GL/freeglut.h)
    ELSE (X11_FOUND AND NOT APPLE)
      SET(vgui_glut_sources ${vgui_glut_sources}
        impl/glut/menu_hack_none.cxx
      )
    ENDIF (X11_FOUND AND NOT APPLE)

    SET( vgui_sources ${vgui_sources} ${vgui_glut_sources} )

  ENDIF(VGUI_USE_GLUT)

ENDIF (GLUT_FOUND)

##################################################
# Qt
##################################################

IF (QT_FOUND)

  OPTION(VGUI_USE_QT "Should Qt support be compiled into vgui?" YES)
  IF(QT3_INSTALLED AND QT4_INSTALLED)
    OPTION(VGUI_USE_QT4 "Specify QT version" YES)
  ELSE(QT3_INSTALLED AND QT4_INSTALLED)
     IF(QT4_INSTALLED)
          SET(VGUI_USE_QT4 YES)

=== core/vidl/CMakeLists.txt ===
# core/vidl/CMakeLists.txt

PROJECT(vidl)

doxygen_add_library(core/vidl
  DEPENDS core/vul core/vil
  PACKAGE core-L2
  DESCRIPTION "Video Sequence Library"
)

INCLUDE( ${VXL_CMAKE_DIR}/NewCMake/FindFFMPEG.cmake )
INCLUDE( ${VXL_CMAKE_DIR}/NewCMake/FindDC1394.cmake )
INCLUDE( ${VXL_CMAKE_DIR}/NewCMake/FindDirectShow.cmake )
FIND_FILE (VIDEODEV_FOUND videodev.h /usr/include/linux/)
FIND_FILE (VIDEODEV2_FOUND videodev2.h /usr/include/linux/)

CONFIGURE_FILE( ${vxl_SOURCE_DIR}/core/vidl/vidl_config.h.in
                ${vxl_BINARY_DIR}/core/vidl/vidl_config.h )

IF( FFMPEG_FOUND )
  INCLUDE_DIRECTORIES(${FFMPEG_INCLUDE_DIR})
ENDIF( FFMPEG_FOUND )

IF(DIRECTSHOW_FOUND)
  INCLUDE_DIRECTORIES(${DIRECTSHOW_INCLUDE_DIRS})

  # For Euresys Multicam Driver's DirectShow source filter.
  # - should I put this in a Module of its own?
  #INCLUDE( ${VXL_CMAKE_DIR}/NewCMake/FindDirectShow_ESF.cmake )
  FIND_PATH(DIRECTSHOW_ESF_INCLUDE_DIR ESFilter.h
            "C:/Program Files/Euresys/MultiCam/Include"
            DOC "What is the path where the file ESFilter.h can be found"
           )
  IF(DIRECTSHOW_ESF_INCLUDE_DIR)
    SET(DIRECTSHOW_ESF_FOUND "YES")
    SET(DIRECTSHOW_ESF_INCLUDE_DIRS "${DIRECTSHOW_ESF_INCLUDE_DIR}")
  ENDIF(DIRECTSHOW_ESF_INCLUDE_DIR)

  IF(DIRECTSHOW_ESF_FOUND)
    INCLUDE_DIRECTORIES(${DIRECTSHOW_ESF_INCLUDE_DIRS})
  ENDIF(DIRECTSHOW_ESF_FOUND)
ENDIF(DIRECTSHOW_FOUND)

SET(vidl_sources
    vidl_config.h.in
    vidl_pixel_format.h           vidl_pixel_format.cxx
    vidl_color.h                  vidl_color.cxx
    vidl_frame.h                  vidl_frame.cxx           vidl_frame_sptr.h
    vidl_pixel_iterator.h         vidl_pixel_iterator.cxx
                                  vidl_pixel_iterator.txx
    vidl_convert.h                vidl_convert.cxx

    vidl_istream.h                vidl_istream_sptr.h
    vidl_image_list_istream.h     vidl_image_list_istream.cxx
    vidl_ostream.h                vidl_ostream_sptr.h
    vidl_image_list_ostream.h     vidl_image_list_ostream.cxx
    vidl_iidc1394_params.h        vidl_iidc1394_params.cxx

    vidl_istream_image_resource.h vidl_istream_image_resource.cxx
   )

# These files are compiled unconditionally.  They will automatically
# compile in stub versions if ffmpeg isn't available.
SET(vidl_sources ${vidl_sources}
    vidl_ffmpeg_istream.h          vidl_ffmpeg_istream.cxx
    vidl_ffmpeg_ostream.h          vidl_ffmpeg_ostream.cxx
    vidl_ffmpeg_ostream_params.h   vidl_ffmpeg_ostream_params.cxx
   )

# These are still conditioned on ffmpeg being available. They should
# also be made unconditional.
IF( FFMPEG_FOUND )
  SET(vidl_sources ${vidl_sources}
      vidl_ffmpeg_init.h             vidl_ffmpeg_init.cxx
      vidl_ffmpeg_convert.h          vidl_ffmpeg_convert.cxx
      vidl_ffmpeg_istream_v1.txx     vidl_ffmpeg_ostream_v1.txx
      vidl_ffmpeg_istream_v2.txx     vidl_ffmpeg_ostream_v2.txx
      vidl_ffmpeg_istream_v3.txx     vidl_ffmpeg_ostream_v3.txx
                                     vidl_ffmpeg_ostream_v4.txx
     )
# Stub implementation, when ffmeg is not available
ELSE( FFMPEG_FOUND )
  SET(vidl_sources ${vidl_sources}
      vidl_ffmpeg_istream_stub.txx
      vidl_ffmpeg_ostream_stub.txx
     )
ENDIF( FFMPEG_FOUND )

IF( DC1394_FOUND )
  SET(vidl_sources ${vidl_sources}
      vidl_dc1394_istream.h          vidl_dc1394_istream.cxx
     )
ENDIF( DC1394_FOUND )

IF(DIRECTSHOW_FOUND)
  SET(vidl_sources ${vidl_sources}
      vidl_exception.h
      vidl_dshow.h                      vidl_dshow.cxx
      vidl_dshow_file_istream.h         vidl_dshow_file_istream.cxx
      vidl_dshow_live_istream.h         vidl_dshow_live_istream.cxx
      vidl_dshow_istream_params.h       vidl_dshow_istream_params.cxx
     )
  IF(DIRECTSHOW_ESF_FOUND)
    SET(vidl_sources ${vidl_sources}
        vidl_dshow_istream_params_esf.h vidl_dshow_istream_params_esf.cxx
       )
  ENDIF(DIRECTSHOW_ESF_FOUND)
ENDIF(DIRECTSHOW_FOUND)

IF(VIDEODEV_FOUND)
   SET(vidl_sources ${vidl_sources}
       vidl_v4l_params.h   vidl_v4l_params.cxx
       vidl_v4l_istream.h  vidl_v4l_istream.cxx
       vidl_v4l_ulong_fix.h
      )
ENDIF(VIDEODEV_FOUND)

IF(VIDEODEV2_FOUND)
   SET(vidl_sources ${vidl_sources}
       vidl_v4l2_devices.h       vidl_v4l2_devices.cxx
       vidl_v4l2_device.h        vidl_v4l2_device.cxx        vidl_v4l2_device_sptr.h
       vidl_v4l2_pixel_format.h  vidl_v4l2_pixel_format.cxx
       vidl_v4l2_istream.h       vidl_v4l2_istream.cxx
       vidl_v4l2_control.h       vidl_v4l2_control.cxx
      )
ENDIF(VIDEODEV2_FOUND)

AUX_SOURCE_DIRECTORY(Templates vidl_sources)

ADD_LIBRARY(vidl ${vidl_sources})
INSTALL_TARGETS(/lib vidl)
INSTALL_NOBASE_HEADER_FILES(/include/vxl/core/vidl ${vidl_sources})

TARGET_LINK_LIBRARIES( vidl vil vul vbl )
IF( FFMPEG_FOUND )
  TARGET_LINK_LIBRARIES( vidl ${FFMPEG_LIBRARIES} )
ENDIF( FFMPEG_FOUND )

IF( DC1394_FOUND )
  TARGET_LINK_LIBRARIES( vidl ${DC1394_LIBRARIES} )
ENDIF( DC1394_FOUND )

IF(DIRECTSHOW_FOUND)
  TARGET_LINK_LIBRARIES( vidl ${DIRECTSHOW_LIBRARIES} )
ENDIF(DIRECTSHOW_FOUND)

# The pixel format conversion function table is generated by a recursive
# template metaprogam with N*N levels of recursion (for N pixel formats)
# The default template depth limit in gcc as of version 4.0.1 is 500.
# This compiler flag is needed to expand that limit.
INCLUDE(CheckCXXCompilerFlag)
SET( TEMPLATE_DEPTH_FLAG -ftemplate-depth-1000 )
CHECK_CXX_COMPILER_FLAG(${TEMPLATE_DEPTH_FLAG} HAS_TEMPLATE_DEPTH_FLAG)
IF( HAS_TEMPLATE_DEPTH_FLAG )
  SET_TARGET_PROPERTIES( vidl PROPERTIES COMPILE_FLAGS ${TEMPLATE_DEPTH_FLAG})
ENDIF( HAS_TEMPLATE_DEPTH_FLAG )

# vgui add on library
SUBDIRS( gui )

IF( BUILD_TESTING )
  SUBDIRS( tests )
ENDIF( BUILD_TESTING )

IF( BUILD_EXAMPLES )
  SUBDIRS( examples )
ENDIF( BUILD_EXAMPLES )

=== core/vil/CMakeLists.txt ===
# core/vil/CMakeLists.txt

doxygen_add_library(core/vil
  DEPENDS core/vnl core/vsl
  PACKAGE core
  DESCRIPTION "Core image library"
)

# avoid undefined macro in subsequent SETs:
SET( vil_sources vil_config.h.in )

INCLUDE(${VXL_CMAKE_DIR}/FindPNG.cmake)
IF(PNG_FOUND)
  INCLUDE_DIRECTORIES( ${PNG_INCLUDE_DIR})
  ADD_DEFINITIONS( ${PNG_DEFINITIONS} )
  SET( HAS_PNG 1 )
  SET( vil_sources ${vil_sources}
    file_formats/vil_png.cxx file_formats/vil_png.h
  )
ELSE(PNG_FOUND)
  SET( HAS_PNG 0 )
ENDIF(PNG_FOUND)

INCLUDE(${VXL_CMAKE_DIR}/FindJPEG.cmake)
IF(JPEG_FOUND)
  INCLUDE_DIRECTORIES( ${JPEG_INCLUDE_DIR} )
  SET( HAS_JPEG 1 )
  SET( vil_sources ${vil_sources}
    file_formats/vil_jpeglib.h
    file_formats/vil_jpeg.cxx                 file_formats/vil_jpeg.h
    file_formats/vil_jpeg_source_mgr.cxx      file_formats/vil_jpeg_source_mgr.h
    file_formats/vil_jpeg_decompressor.cxx    file_formats/vil_jpeg_decompressor.h
    file_formats/vil_jpeg_destination_mgr.cxx file_formats/vil_jpeg_destination_mgr.h
    file_formats/vil_jpeg_compressor.cxx      file_formats/vil_jpeg_compressor.h
  )
ELSE(JPEG_FOUND)
  SET( HAS_JPEG 0 )
ENDIF(JPEG_FOUND)

################################
# JPEG 2000
################################
INCLUDE( ${VXL_CMAKE_DIR}/NewCMake/FindECW.cmake )
IF(ECW_FOUND)
  SET( vil_sources ${vil_sources}
    file_formats/vil_j2k_image.h           file_formats/vil_j2k_image.cxx
    file_formats/NCSJPCVilIOStream.h       file_formats/NCSJPCVilIOStream.cxx
    file_formats/vil_j2k_nitf2_pyramid_image_resource.h
    file_formats/vil_j2k_nitf2_pyramid_image_resource.cxx
    file_formats/vil_j2k_pyramid_image_resource.h
    file_formats/vil_j2k_pyramid_image_resource.cxx
  )
  INCLUDE_DIRECTORIES(${ECW_INCLUDE_DIR})
  SET( HAS_J2K 1 )
ELSE(ECW_FOUND)
  SET( HAS_J2K 0 )
ENDIF(ECW_FOUND)

##############################
# JPEG2000 via OpenJPEG
##############################
INCLUDE( ${VXL_CMAKE_DIR}/FindOpenJPEG2.cmake )
IF(OPENJPEG2_FOUND)
  INCLUDE_DIRECTORIES(${OPENJPEG2_INCLUDE_DIR})
  ADD_DEFINITIONS( ${OPENJPEG2_DEFINITIONS} )
  SET( vil_sources ${vil_sources}
    file_formats/vil_openjpeg.h  file_formats/vil_openjpeg.cxx
    file_formats/vil_openjpeg_pyramid_image_resource.h
    file_formats/vil_openjpeg_pyramid_image_resource.cxx
  )
  ADD_DEFINITIONS( ${OPENJPEG2_DEFINITIONS} )
  SET( HAS_OPENJPEG2 1 )
ELSE(OPENJPEG2_FOUND)
  SET( HAS_OPENJPEG2 0 )
ENDIF(OPENJPEG2_FOUND)

SET( HAS_TIFF 0 )
SET( HAS_GEOTIFF 0 )
INCLUDE(${VXL_CMAKE_DIR}/FindTIFF.cmake)
IF(TIFF_FOUND)
  INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
  SET( HAS_TIFF 1 )
  SET( vil_sources ${vil_sources}
    file_formats/vil_tiff.cxx file_formats/vil_tiff.h
    file_formats/vil_tiff_header.cxx file_formats/vil_tiff_header.h
  )

  INCLUDE( ${VXL_CMAKE_DIR}/FindGEOTIFF.cmake)
  IF(GEOTIFF_FOUND)
    #ADD_DEFINITIONS( -DHAS_GEOTIFF )
    SET (HAS_GEOTIFF 1 )
    INCLUDE_DIRECTORIES(${GEOTIFF_INCLUDE_DIR})
    SET( vil_sources ${vil_sources}
      file_formats/vil_geotiff_header.cxx file_formats/vil_geotiff_header.h
    )
  ENDIF(GEOTIFF_FOUND)
ENDIF(TIFF_FOUND)

INCLUDE(${VXL_CMAKE_DIR}/FindDCMTK.cmake)
IF(DCMTK_FOUND)
  INCLUDE_DIRECTORIES(${DCMTK_INCLUDE_DIR})
  SET( HAS_DCMTK 1 )
  SET( vil_sources ${vil_sources}
    file_formats/vil_dicom.cxx        file_formats/vil_dicom.h
    file_formats/vil_dicom_stream.cxx file_formats/vil_dicom_stream.h
    file_formats/vil_dicom_header.cxx file_formats/vil_dicom_header.h
  )
ELSE(DCMTK_FOUND)
  SET( HAS_DCMTK 0 )
ENDIF(DCMTK_FOUND)

OPTION(VIL_CONFIG_ENABLE_SSE2_ROUNDING
       "Enable Streaming SIMD Extensions 2 implementation of rounding (hardware dependant)."
       ${VXL_HAS_SSE2_HARDWARE_SUPPORT} )
IF( VIL_CONFIG_ENABLE_SSE2_ROUNDING )
  IF( NOT VXL_HAS_SSE2_HARDWARE_SUPPORT )
    IF( VXL_SSE2_HARDWARE_SUPPORT_POSSIBLE )
      MESSAGE( ${VXL_SSE2_HARDWARE_SUPPORT_POSSIBLE_HELP} )
    ENDIF( VXL_SSE2_HARDWARE_SUPPORT_POSSIBLE )
    MESSAGE( SEND_ERROR "Cannot have VIL_CONFIG_ENABLE_SSE2_ROUNDING because"
                        " there is no SSE2 hardware or no compiler support enabled" )
    SET(VIL_CONFIG_ENABLE_SSE2_ROUNDING 0)
  ENDIF( NOT VXL_HAS_SSE2_HARDWARE_SUPPORT )
ENDIF( VIL_CONFIG_ENABLE_SSE2_ROUNDING )


IF(VIL_CONFIG_ENABLE_SSE2_ROUNDING)
  SET(VIL_CONFIG_ENABLE_SSE2_ROUNDING 1)
ELSE(VIL_CONFIG_ENABLE_SSE2_ROUNDING)
  SET(VIL_CONFIG_ENABLE_SSE2_ROUNDING 0)
ENDIF(VIL_CONFIG_ENABLE_SSE2_ROUNDING)


# Store the external library configurations in to the config file
CONFIGURE_FILE( ${vxl_SOURCE_DIR}/core/vil/vil_config.h.in
                ${vxl_BINARY_DIR}/core/vil/vil_config.h @ONLY IMMEDIATE )

SET( vil_sources ${vil_sources}

  # basic things
  vil_memory_chunk.cxx                  vil_memory_chunk.h
  vil_image_view_base.h
  vil_chord.h
  vil_image_view.h                      vil_image_view.txx
  vil_image_resource.cxx                vil_image_resource.h
                                        vil_image_resource_sptr.h
  vil_blocked_image_resource.cxx        vil_blocked_image_resource.h
                                        vil_blocked_image_resource_sptr.h
  vil_blocked_image_facade.cxx          vil_blocked_image_facade.h
  vil_file_format.cxx                   vil_file_format.h
  vil_memory_image.cxx                  vil_memory_image.h
  vil_block_cache.cxx                   vil_block_cache.h
  vil_cached_image_resource.cxx         vil_cached_image_resource.h
  vil_pyramid_image_resource.cxx        vil_pyramid_image_resource.h
                                        vil_pyramid_image_resource_sptr.h
  vil_pyramid_image_view.txx            vil_pyramid_image_view.h
  vil_image_list.cxx                    vil_image_list.h
  # file format readers/writers (see above for conditional ones)


  file_formats/vil_pnm.cxx              file_formats/vil_pnm.h

  file_formats/vil_bmp_file_header.cxx  file_formats/vil_bmp_file_header.h
  file_formats/vil_bmp_core_header.cxx  file_formats/vil_bmp_core_header.h
  file_formats/vil_bmp_info_header.cxx  file_formats/vil_bmp_info_header.h
  file_formats/vil_bmp.cxx              file_formats/vil_bmp.h

  file_formats/vil_ras.cxx              file_formats/vil_ras.h

  file_formats/vil_iris.cxx             file_formats/vil_iris.h

  file_formats/vil_mit.cxx              file_formats/vil_mit.h


  file_formats/vil_viff.cxx             file_formats/vil_viff.h
  file_formats/vil_viffheader.cxx       file_formats/vil_viffheader.h

  ################################
  # NITF 2.0 and 2.1 reading code
  ################################
  # The actual vil_image_resource subclass
  file_formats/vil_nitf2_image.h                    file_formats/vil_nitf2_image.cxx

  # For reading the NITF file headers as well as the image headers
  file_formats/vil_nitf2_header.h                   file_formats/vil_nitf2_header.cxx
  file_formats/vil_nitf2_image_subheader.h          file_formats/vil_nitf2_image_subheader.cxx
  file_formats/vil_nitf2_des.h                      file_formats/vil_nitf2_des.cxx

  # Stuff shared by all NITF2 classes
  file_formats/vil_nitf2.h                          file_formats/vil_nitf2.cxx

  # Generic framework for reading NITF tagged record extensions (TREs)
  file_formats/vil_nitf2_array_field.h              file_formats/vil_nitf2_array_field.cxx
  file_formats/vil_nitf2_classification.h           file_formats/vil_nitf2_classification.cxx
  file_formats/vil_nitf2_compound_field_value.h     file_formats/vil_nitf2_compound_field_value.cxx
  file_formats/vil_nitf2_data_mask_table.h          file_formats/vil_nitf2_data_mask_table.cxx
  file_formats/vil_nitf2_field.h                    file_formats/vil_nitf2_field.cxx
  file_formats/vil_nitf2_field_definition.h         file_formats/vil_nitf2_field_definition.cxx
  file_formats/vil_nitf2_field_formatter.h          file_formats/vil_nitf2_field_formatter.cxx
  file_formats/vil_nitf2_field_functor.h            file_formats/vil_nitf2_field_functor.cxx
  file_formats/vil_nitf2_field_sequence.h           file_formats/vil_nitf2_field_sequence.cxx
  file_formats/vil_nitf2_index_vector.h
  file_formats/vil_nitf2_scalar_field.h             file_formats/vil_nitf2_scalar_field.cxx
  file_formats/vil_nitf2_tagged_record.h            file_formats/vil_nitf2_tagged_record.cxx
  file_formats/vil_nitf2_tagged_record_definition.h file_formats/vil_nitf2_tagged_record_definition.cxx
  file_formats/vil_nitf2_typed_array_field.h
  file_formats/vil_nitf2_typed_scalar_field.h
  file_formats/vil_nitf2_typed_field_formatter.h    file_formats/vil_nitf2_typed_field_formatter.cxx

  file_formats/vil_pyramid_image_list.h             file_formats/vil_pyramid_image_list.cxx
  # image operations
  vil_crop.cxx                          vil_crop.h
  vil_clamp.cxx                         vil_clamp.h
  vil_transpose.cxx                     vil_transpose.h
  vil_flip.cxx                          vil_flip.h
  vil_plane.cxx                         vil_plane.h
  vil_math.cxx                          vil_math.h
  vil_view_as.h
  vil_convert.h
  vil_fill.h
  vil_transform.h
  vil_decimate.cxx                      vil_decimate.h
  vil_load.cxx                          vil_load.h
  vil_save.cxx                          vil_save.h
  vil_copy.txx       vil_copy.cxx       vil_copy.h
  vil_new.cxx                           vil_new.h
  vil_print.cxx                         vil_print.h
  vil_warp.h
  vil_flatten.h

  # Bilinear Sampling Operations
  vil_bilin_interp.h
  vil_sample_profile_bilin.txx          vil_sample_profile_bilin.h
  vil_sample_grid_bilin.txx             vil_sample_grid_bilin.h
  vil_resample_bilin.txx                vil_resample_bilin.h
  vil_rotate.txx                        vil_rotate.h

  # Bicubic Sampling Operations
  vil_bicub_interp.txx                  vil_bicub_interp.h
  vil_sample_profile_bicub.txx          vil_sample_profile_bicub.h
  vil_sample_grid_bicub.txx             vil_sample_grid_bicub.h
  vil_resample_bicub.txx                vil_resample_bicub.h

  # Nearest Neighbour Sampling Operations
  vil_nearest_interp.h
  vil_resample_nearest.txx              vil_resample_nearest.h

  # Stuff
  vil_border.h
  vil_smart_ptr.txx                     vil_smart_ptr.h
  vil_property.h
  vil_pixel_format.cxx                  vil_pixel_format.h
  vil_exception.h
  vil_rgb.txx                           vil_rgb.h
  vil_rgba.txx                          vil_rgba.h
  vil_color_table.h
  vil_fwd.h
  vil_round.h
  vil_na.cxx                            vil_na.h

  # Streams
  vil_stream.cxx                        vil_stream.h
  vil_stream_fstream.cxx                vil_stream_fstream.h
  vil_stream_core.cxx                   vil_stream_core.h
  vil_stream_section.cxx                vil_stream_section.h
  vil_open.cxx                          vil_open.h
  vil_stream_read.cxx                   vil_stream_read.h
  vil_stream_write.cxx                  vil_stream_write.h

  # Plugin for image loading
  vil_image_resource_plugin.cxx         vil_image_resource_plugin.h
)

IF (WIN32 AND VXL_USE_LFS AND NOT CMAKE_CL_64)
#This is a hack since win32 doesn't have transparent Large File Support.
  ADD_DEFINITIONS( -DVIL_USE_FSTREAM64 )
  SET( vil_sources ${vil_sources}
    vil_stream_fstream64.cxx        vil_stream_fstream64.h
  )
ENDIF (WIN32 AND VXL_USE_LFS AND NOT CMAKE_CL_64)

AUX_SOURCE_DIRECTORY(Templates vil_sources)

IF(CMAKE_COMPILER_IS_GNUCXX)
  SET_SOURCE_FILES_PROPERTIES(vil_na.cxx PROPERTIES COMPILE_FLAGS -O1)
ENDIF(CMAKE_COMPILER_IS_GNUCXX)


# Some versions of Solaris (at least 5.8) has a brain-dead mechanism
# for implementing DNS services, where the user of a library that uses
# gethostbyname should link to -lnsl *before* linking to the
# library. This creates a kind of "pre-dependency" that the CMake
# dependency analysis is not equipped to handle. We cope by isolating
# the offending code into its own library vil_network (under Solaris
# only, of course). We can then control the dependencies of vil to
# link nsl before this vil_network.
#
# This workaround also occurs in vul
#

=== core/vil1/CMakeLists.txt ===
# vxl/vil1/CMakeLists.txt

SET( vil1_sources
  vil1_fwd.h

  # basic things
  vil1_pixel.cxx                             vil1_pixel.h
  vil1_image_impl.cxx                        vil1_image_impl.h
  vil1_image.cxx                             vil1_image.h
  vil1_stream.cxx                            vil1_stream.h
  vil1_file_format.cxx                       vil1_file_format.h
  vil1_byte_swap.cxx                         vil1_byte_swap.h
  vil1_16bit.cxx                             vil1_16bit.h
  vil1_32bit.cxx                             vil1_32bit.h
  vil1_rgb.txx                               vil1_rgb.h
  vil1_rgba.txx                              vil1_rgba.h
  vil1_rgb_byte.h
  vil1_property.h

  # various vil1_stream classes
  # from a file
  vil1_stream_fstream.cxx                    vil1_stream_fstream.h
  # in-core vil1_stream
  vil1_stream_core.cxx                       vil1_stream_core.h
  # present a section of a vil1_stream
  vil1_stream_section.cxx                    vil1_stream_section.h

  # classes derived from vil1_image
  vil1_file_image.cxx                        vil1_file_image.h
  vil1_memory_image.cxx                      vil1_memory_image.h
  vil1_image_proxy.cxx                       vil1_image_proxy.h
  vil1_memory_image_of.txx                   vil1_memory_image_of.h
  vil1_memory_image_of_format.txx

  # image adaptors
  vil1_memory_image_impl.cxx                 vil1_memory_image_impl.h
  vil1_crop_image_impl.cxx                   vil1_crop_image_impl.h
  vil1_skip_image_impl.cxx                   vil1_skip_image_impl.h
  vil1_resample_image_impl.cxx               vil1_resample_image_impl.h
  vil1_flipud_impl.cxx                       vil1_flipud_impl.h
  vil1_flip_components_impl.cxx              vil1_flip_components_impl.h
  vil1_block_cache_image_impl.cxx            vil1_block_cache_image_impl.h
  vil1_clamp_image_impl.cxx                  vil1_clamp_image_impl.h
  # Helper specializations for vil1_clamp_image_impl
  vil1_clamp_image.cxx                       vil1_clamp_image.h
  vil1_scale_intensities_image_impl.cxx      vil1_scale_intensities_image_impl.h
  # Helper specializations for               vil1_scale_intensities_image_impl
  vil1_scale_intensities_image.cxx           vil1_scale_intensities_image.h
  # Wrapper classes for vil/vil1 conversion
  vil1_vil.h

  # file format readers/writers (see below for conditional ones)
  file_formats/vil1_gen.cxx                  file_formats/vil1_gen.h
  file_formats/vil1_pnm.cxx                  file_formats/vil1_pnm.h
  file_formats/vil1_viff.cxx                 file_formats/vil1_viff.h
  file_formats/vil1_viff_support.c           file_formats/vil1_viff_support.h file_formats/vil1_viffheader.h
  file_formats/vil1_iris.cxx                 file_formats/vil1_iris.h
  file_formats/vil1_mit.cxx                  file_formats/vil1_mit.h
  file_formats/vil1_bmp_file_header.cxx      file_formats/vil1_bmp_file_header.h
  file_formats/vil1_bmp_core_header.cxx      file_formats/vil1_bmp_core_header.h
  file_formats/vil1_bmp_info_header.cxx      file_formats/vil1_bmp_info_header.h
  file_formats/vil1_bmp.cxx                  file_formats/vil1_bmp.h
  file_formats/vil1_gif.cxx                  file_formats/vil1_gif.h
  file_formats/vil1_ras.cxx                  file_formats/vil1_ras.h

  # Operations
  vil1_image_as.cxx                          vil1_image_as.h
  vil1_new.cxx                               vil1_new.h
  vil1_open.cxx                              vil1_open.h
  vil1_load.cxx                              vil1_load.h
  vil1_save.cxx                              vil1_save.h
  vil1_copy.cxx                              vil1_copy.h
  vil1_crop.cxx                              vil1_crop.h
  vil1_skip.cxx                              vil1_skip.h
  vil1_resample.cxx                          vil1_resample.h
  vil1_warp.txx  vil1_warp.cxx               vil1_warp.h
  vil1_flipud.cxx                            vil1_flipud.h
  vil1_flip_components.cxx                   vil1_flip_components.h
  vil1_smooth.cxx                            vil1_smooth.h
  vil1_clamp.cxx                             vil1_clamp.h
  vil1_scale_intensities.cxx                 vil1_scale_intensities.h
  vil1_convolve.txx                          vil1_convolve.h
  vil1_convolve_1d.txx
  vil1_convolve_1d_x.txx
  vil1_convolve_1d_y.txx
  vil1_convolve_simple.txx                   vil1_convolve_simple.h
  vil1_interpolate.txx                       vil1_interpolate.h
  vil1_ncc.txx                               vil1_ncc.h
  vil1_resample_image.txx                    vil1_resample_image.h
  vil1_ssd.txx                               vil1_ssd.h

  # Stuff
  vil1_pyramid.cxx                           vil1_pyramid.h
  vil1_colour_space.cxx                      vil1_colour_space.h
  vil1_memory_image_window.cxx               vil1_memory_image_window.h
  vil1_ip_traits.h
)

# Some versions of Solaris (at least 5.8) has a brain-dead mechanism
# for implementing DNS services, where the user of a library that uses
# gethostbyname should link to -lnsl *before* linking to the
# library. This creates a kind of "pre-dependency" that the CMake
# dependency analysis is not equipped to handle. We cope by isolating
# the offending code into its own library vil1_network (under Solaris
# only, of course). We can then control the dependencies of vil1 to
# link nsl before this vil1_network.
#
SET( vil1_network_sources
  # load image from URL
  vil1_stream_url.cxx                        vil1_stream_url.h
)

# vil1_stream_url not working on Apple MacOSX
IF(NOT APPLE)
# vil1_stream_url in separate library on Solaris
  IF(SOLARIS)
    ADD_LIBRARY(vil1_network ${vil1_network_sources})
    INSTALL_TARGETS(lib/ vil1_network)
    INSTALL_NOBASE_HEADER_FILES(/include/vxl/core/vil1 ${vil1_network_sources})
  ELSE(SOLARIS)
    SET(vil1_sources ${vil1_sources} ${vil1_network_sources})
  ENDIF(SOLARIS)
ENDIF(NOT APPLE)

# vil1_file_formats.cxx uses -DTIFF, etc, so we need to do this here.
INCLUDE(${VXL_CMAKE_DIR}/FindJPEG.cmake)
INCLUDE(${VXL_CMAKE_DIR}/FindPNG.cmake)
INCLUDE(${VXL_CMAKE_DIR}/FindTIFF.cmake)

IF(PNG_FOUND)
  INCLUDE_DIRECTORIES( ${PNG_INCLUDE_DIR})
  ADD_DEFINITIONS( ${PNG_DEFINITIONS}  -DHAS_PNG=1 )
  SET( vil1_sources ${vil1_sources}
    file_formats/vil1_png.cxx                  file_formats/vil1_png.h
  )
ELSE(PNG_FOUND)
  ADD_DEFINITIONS( -DHAS_PNG=0 )
ENDIF(PNG_FOUND)

IF(JPEG_FOUND)
  INCLUDE_DIRECTORIES( ${JPEG_INCLUDE_DIR} )
  ADD_DEFINITIONS( ${JPEG_DEFINITIONS} -DHAS_JPEG=1 )
  SET( vil1_sources ${vil1_sources}
    vil1_jpeglib.h
    file_formats/vil1_jpeg.cxx                  file_formats/vil1_jpeg.h
    file_formats/vil1_jpeg_source_mgr.cxx       file_formats/vil1_jpeg_source_mgr.h
    file_formats/vil1_jpeg_decompressor.cxx     file_formats/vil1_jpeg_decompressor.h
    file_formats/vil1_jpeg_destination_mgr.cxx  file_formats/vil1_jpeg_destination_mgr.h
    file_formats/vil1_jpeg_compressor.cxx       file_formats/vil1_jpeg_compressor.h
  )
ELSE(JPEG_FOUND)
  ADD_DEFINITIONS( -DHAS_JPEG=0 )
ENDIF(JPEG_FOUND)

IF(TIFF_FOUND)
  INCLUDE_DIRECTORIES( ${TIFF_INCLUDE_DIR} )
  ADD_DEFINITIONS( ${TIFF_DEFINITIONS} -DHAS_TIFF=1 )
  SET( vil1_sources ${vil1_sources}
    file_formats/vil1_tiff.cxx                  file_formats/vil1_tiff.h
  )
ELSE(TIFF_FOUND)
  ADD_DEFINITIONS( -DHAS_TIFF=0 )
ENDIF(TIFF_FOUND)

AUX_SOURCE_DIRECTORY(Templates vil1_sources)

IF(CMAKE_COMPILER_IS_GNUCXX)
  SET_SOURCE_FILES_PROPERTIES(vil1_image_as.cxx PROPERTIES COMPILE_FLAGS -O0)
ENDIF(CMAKE_COMPILER_IS_GNUCXX)

ADD_LIBRARY(vil1 ${vil1_sources})
INSTALL_TARGETS(/lib vil1)
INSTALL_NOBASE_HEADER_FILES(/include/vxl/core/vil1 ${vil1_sources})

IF(JPEG_FOUND)
  TARGET_LINK_LIBRARIES( vil1 ${JPEG_LIBRARIES} )
ENDIF(JPEG_FOUND)
IF(TIFF_FOUND)
  TARGET_LINK_LIBRARIES( vil1 ${TIFF_LIBRARIES} )
ENDIF(TIFF_FOUND)
IF(PNG_FOUND)
  TARGET_LINK_LIBRARIES( vil1 ${PNG_LIBRARIES} )
ENDIF(PNG_FOUND)

TARGET_LINK_LIBRARIES( vil1 vcl )

IF (NOT UNIX)
  TARGET_LINK_LIBRARIES( vil1 ws2_32 )
ENDIF (NOT UNIX)

IF(SOLARIS)
  TARGET_LINK_LIBRARIES( vil1 nsl vil1_network socket )
ENDIF(SOLARIS)


IF( BUILD_EXAMPLES )
  SUBDIRS( examples )
ENDIF( BUILD_EXAMPLES )
IF( BUILD_TESTING )
  SUBDIRS(tests)
ENDIF( BUILD_TESTING )

=== debian/changelog ===
vxl (1.17.0-8) unstable; urgency=high

  * Remove B-D: libtiff5-dev, as it makes vxl FTBFS. Closes: #721493

 -- Mathieu Malaterre <malat@debian.org>  Fri, 29 Nov 2013 08:41:19 +0100

vxl (1.17.0-7) unstable; urgency=high

  * Hide symptoms from --as-needed on IA64. Closes: #728574
  * Update d/copyright. Closes: #723126

 -- Mathieu Malaterre <malat@debian.org>  Thu, 28 Nov 2013 14:52:51 +0100

vxl (1.17.0-6) unstable; urgency=medium

  * Remove B-D: libtiff5-dev, as it makes vxl FTBFS. Closes: #721493
  * wrap and sort d/control
  * Remove -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo from d/rules

 -- Mathieu Malaterre <malat@debian.org>  Mon, 02 Sep 2013 09:21:29 +0200

vxl (1.17.0-5) unstable; urgency=low

  * Use libcoin80-dev for transition
  * Fix compilation of opencl module on kFreeBSD

 -- Mathieu Malaterre <malat@debian.org>  Thu, 30 May 2013 10:44:57 +0200

vxl (1.17.0-4) unstable; urgency=low

  * Fix builds on arm* by removing duplicate symbols
  * Re-activate testing. Closes: #671601
  * Build OpenCL modules. Closes: #697784
  * Run two cmake configure steps. Closes: #708131
  * make package multiarch

 -- Mathieu Malaterre <malat@debian.org>  Tue, 28 May 2013 15:08:55 +0200

vxl (1.17.0-3) unstable; urgency=low

  * Import old patch and avoid name clash. Closes: #708666, #708668
  * Re-import old sse2.patch, fix compilation.
  * Re-import old ffmpeg/C99 patch. Closes: #708740

 -- Mathieu Malaterre <malat@debian.org>  Sun, 19 May 2013 16:11:07 +0200

vxl (1.17.0-2) unstable; urgency=low

  * Upload to sid.
  * Fix comp with libav. Closes: #693543
    + debian/patches/libav_trunk.patch
  * Fix compilation issues. Closes: #708358
    + debian/patches/bug708358.patch
  * Fix compilation. Closes: #707472
    + debian/patches/bug707472.patch

 -- Mathieu Malaterre <malat@debian.org>  Wed, 15 May 2013 16:53:56 +0200

vxl (1.17.0-1) experimental; urgency=low

  * New upstream
  * Use shapelib package
  * Remove deprecated DMUA flag
  * Bump Std-Vers to 3.9.4, no changes needed
  * Re-add avifile binding (see #647787)

 -- Mathieu Malaterre <malat@debian.org>  Fri, 28 Dec 2012 22:31:32 +0100

=== debian/control ===
Source: vxl
Homepage: http://vxl.sf.net
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>,
           Andreas Tille <tille@debian.org>
Build-Depends: cmake (>= 2.4.5),
               debhelper (>= 9),
               freeglut3-dev,
               libavcodec-dev,
               libavformat-dev,
               libavifile-0.7-dev,
               libbz2-dev,
               libcoin80-dev,
               libdc1394-22-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
               libdcmtk2-dev,
               libexpat-dev,
               libgeotiff-dev, libtiff-dev,
               libglu-dev,
               libjpeg-dev,
               libmpeg2-4-dev,
               libpng-dev,
               libqt4-dev,
               libqt4-opengl-dev,
               libshp-dev,
               libswscale-dev,
               libxerces-c-dev,
               ocl-icd-opencl-dev,
               opencl-headers,
               python-dev (>= 2.6.6-3~),
               zlib1g-dev
Standards-Version: 3.9.4
X-Python-Version: 2.7
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/vxl/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/vxl/trunk/

Package: libvxl1.17
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ Libraries for Computer Vision Research
 VXL (the Vision-something-Libraries) is a collection of C++ libraries
 designed for computer vision research and implementation. It was created
 from TargetJr and the IUE with the aim of making a light, fast and
 consistent system. VXL is written in ANSI/ISO C++ and is designed to be
 portable over many platforms.

Package: libvxl1-dev
Section: libdevel
Architecture: any
Depends: libvxl1.17 (= ${binary:Version}), ${misc:Depends}
Provides: libvxl-dev
Description: C++ Libraries for Computer Vision Research
 VXL (the Vision-something-Libraries) is a collection of C++ libraries
 designed for computer vision research and implementation. It was created
 from TargetJr and the IUE with the aim of making a light, fast and
 consistent system. VXL is written in ANSI/ISO C++ and is designed to be
 portable over many platforms.
 .
 This package contains the development files needed to build your own
 VXL applications.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

# http://bugs.debian.org/718047
# -> debian-release team blessing: http://bugs.debian.org/728574#18
ifneq ($(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU ), ia64)
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
endif

VER_FULL = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d-)
SOVERSION = $(shell echo $(VER_FULL) | cut -f1-2 -d.)
VER_MAJOR = $(shell echo $(VER_FULL) | cut -f1   -d.)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

UPSTREAM_SRC = vxl-$(VER_FULL)
DEBIAN_SRC_DIR = vxl-$(VER_FULL)
DEBIAN_SRC_TAR = vxl_$(VER_FULL).orig.tar.gz

PYTHON_INCLUDE_DIRS=$(shell python-config --includes | cut -f1 -d' '|cut -c3-)
PYTHON_INCLUDE_DIR="$(PYTHON_INCLUDE_DIRS)"
# See bug #709181
PYTHON_INCLUDE_DIRS2=$(shell python-config --includes | cut -f2 -d' '|cut -c3-)
PYTHON_INCLUDE_DIR2="$(PYTHON_INCLUDE_DIRS2)"
PYTHON_CONFIG_DIR=$(shell python-config --configdir)
PYTHON_LIBRARY="$(PYTHON_CONFIG_DIR)/libpython2.7.so"

# CMAKE_SKIP_RPATH=OFF is required when BUILD_TESTING=ON
# Do not set CMAKE_BUILD_TYPE / http://bugs.debian.org/711515
CMAKE_EXTRA_FLAGS = \
	-DCMAKE_INSTALL_PREFIX:PATH=/usr \
	-DCMAKE_BUILD_TYPE:STRING="" \
	-DCMAKE_SKIP_RPATH:BOOL=OFF \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DAVIFILE_INCLUDE_DIR:PATH=/usr/include/avifile-0.7 \
	-DVXL_USING_NATIVE_ZLIB:BOOL=ON \
	-DVXL_USING_NATIVE_JPEG:BOOL=ON \
	-DVXL_USING_NATIVE_BZLIB2:BOOL=ON \
	-DVXL_USING_NATIVE_MPEG2:BOOL=ON \
	-DVXL_USING_NATIVE_PNG:BOOL=ON \
	-DVXL_USING_NATIVE_TIFF:BOOL=ON \
	-DVXL_USING_NATIVE_SHAPELIB:BOOL=ON \
	-DVXL_USING_NATIVE_GEOTIFF:BOOL=ON \
	-DVXL_USING_NATIVE_EXPAT:BOOL=ON \
	-DBUILD_VGUI:BOOL=ON \
	-DBUILD_BGUI3D:BOOL=ON \
	-DVXL_BUILD_DCMTK:BOOL=ON \
	-DBUILD_OXL:BOOL=ON \
	-DBUILD_CORE_GEOMETRY:BOOL=ON \
	-DBUILD_CORE_IMAGING:BOOL=ON \
	-DBUILD_CORE_NUMERICS:BOOL=ON \
	-DBUILD_CORE_PROBABILITY:BOOL=ON \
	-DBUILD_CORE_SERIALISATION:BOOL=ON \
	-DBUILD_CORE_UTILITIES:BOOL=ON \
	-DBUILD_CORE_VIDEO:BOOL=ON \
	-DBUILD_EXAMPLES:BOOL=OFF \
	-DPYTHON_INCLUDE_DIR=$(PYTHON_INCLUDE_DIR) \
	-DPYTHON_INCLUDE_DIR2=$(PYTHON_INCLUDE_DIR2) \
	-DPYTHON_LIBRARY=$(PYTHON_LIBRARY) \
	-DBUILD_TESTING:BOOL=ON

pkg_lib = libvxl$(SOVERSION)
pkg_dev = libvxl$(VER_MAJOR)-dev
#pkg_examples = vxl$(VER_MAJOR)-examples

%:
	dh $@ --buildsystem=cmake --parallel --with python2

override_dh_auto_configure:
	# remove duplicate from boxm_block+boct_tree+short.vnl_vector_fixed+float
	rm -f $(CURDIR)/contrib/brl/bseg/boxm/pro/Templates/boxm_scene+boct_tree+short.vnl_vector_fixed+float.3---.cxx
	dh_auto_configure # See bug: 708131
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_lintian:
	echo "$(pkg_lib): package-name-doesnt-match-sonames" > debian/$(pkg_lib).lintian-overrides
	dh_lintian

override_dh_install:
	dh_install -p$(pkg_lib) debian/tmp/usr/lib/lib*.so.* usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/lib*.so usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/vxl/cmake/*.cmake 

# too many tests failure, with erratic behavior
# http://bugs.debian.org/671601
override_dh_auto_test:
	dh_auto_test || true

get-orig-source:
	uscan --verbose --force-download --rename

=== debian/watch ===
version=3
http://sf.net/vxl/vxl-([\d\.]+)\.tar.gz
